//
// Copyright (c) Microsoft Corporation.  All rights reserved.
//
//
// Use of this source code is subject to the terms of the Microsoft end-user
// license agreement (EULA) under which you licensed this SOFTWARE PRODUCT.
// If you did not accept the terms of the EULA, you are not authorized to use
// this source code. For a copy of the EULA, please see the LICENSE.RTF on your
// install media.
//
/*
   Definitions for kernel-mode signature verification

*/


#define MAX_RSA_KEY_BITS    1024
#define MAX_RSA_KEY_DIGITS  (MAX_RSA_KEY_BITS/32)
#define RSA_KEY_BITS        MAX_RSA_KEY_BITS
#define RSA_KEY_DIGITS      (RSA_KEY_BITS/32)

#define WIN_CERT_TYPE_PKCS1_SIGN     9       // 1,2,3 are defined in winbase.h
#define MAX_WIN_CERT_SIGN_DATA_LEN  128      // max signed attribute bytes allowed 

typedef struct {
        // standard WIN_CERTIFICATE fields (8 bytes)
        DWORD dwLength;
        WORD wRevision;
        WORD wCertificateType;
        // WIN_CERT_TYPE_PKCS1_SIGN fields follow
        DWORD cbSignedData;   //  0 <= cbSignedData <= MAX_SIGN_DATA_LEN
        BYTE bSignedData[MAX_WIN_CERT_SIGN_DATA_LEN];  // optional signed attributes
        BYTE bSign[MAX_RSA_KEY_BITS/8]; // PKCS1 signature
} PKCS1_MODULE_SIGN ;

