@echo off
@echo "Usage: makekey.bat <key file name>"

set OBJ_NAME="CN=UM, O=Philips Medical Systems"

if not exist %1.pvk goto del_pvk_done
del /f /q %1.pvk > nul
:del_pvk_done
if not exist %1.spc goto del_spc_done
del /f /q %1.spc > nul
:del_spc_done
if not exist %1.pfx goto del_pfx_done
del /f /q %1.pfx > nul
:del_pfx_done
if not exist %1.cer goto del_cer_done
del /f /q %1.cer > nul
:del_cer_done

@echo Creating %1.cer and %1.pvk...
makecert -sv %1.pvk -a sha1 -sky signature -n %OBJ_NAME% %1.cer
@echo Done.

@echo Converting %1.cer file into %1.spc...
cert2spc %1.cer %1.spc
@echo Done.

@echo Creating %1.pfx using %1.spc and %1.pvk...
pvk2pfx.exe -pvk %1.pvk -spc %1.spc -f -pfx %1.pfx
@echo Done.

del /f /q %1.pvk > nul
del /f /q %1.cer > nul
del /f /q %1.spc > nul
